Index: /code/branches/modularships/src/orxonox/items/PartDestructionEvent.cc
===================================================================
--- /code/branches/modularships/src/orxonox/items/PartDestructionEvent.cc	(revision 10070)
+++ /code/branches/modularships/src/orxonox/items/PartDestructionEvent.cc	(revision 10071)
@@ -143,4 +143,6 @@
             switch (this->targetParam_) {
             case null:
+                if (!this->parent_->getParent()->getShipPartByName(targetName_))
+                    return;
                 this->parent_->getParent()->getShipPartByName(targetName_)->setEventExecution(false);
                 this->parent_->getParent()->killShipPart(targetName_);
Index: /code/branches/modularships/src/orxonox/items/ShipPart.cc
===================================================================
--- /code/branches/modularships/src/orxonox/items/ShipPart.cc	(revision 10070)
+++ /code/branches/modularships/src/orxonox/items/ShipPart.cc	(revision 10071)
@@ -55,4 +55,5 @@
         this->setAlive(true);
         this->setEventExecution(true);
+        this->healthMem_ = 100;
     }
 
@@ -102,4 +103,5 @@
         // Remove this ShipPart from the parent.
         this->parent_->removeShipPart(this);
+        delete this;
     }
 
@@ -201,4 +203,10 @@
     {
         this->health_ = health;
+    }
+
+    void ShipPart::setAlive(bool var)
+    {
+        this->alive_ = var;
+        orxout() << "ShipPart " << this->getName() << " alive_: " << this->alive_ << endl;
     }
 
@@ -236,21 +244,25 @@
 
         // (Ugly) Chatoutput of health, until a GUI for modularspaceships-shipparts is implemented.
-        if (this->health_ < 0.2 * this->maxHealth_)
-        {
+        if ((this->health_ < 0.2 * this->maxHealth_) && (this->healthMem_ == 40))
+        {
+            this->healthMem_ = 20;
             ChatManager::message("ShipPart " + this->getName() + " remaining health is 20%!");
             return;
         }
-        if (this->health_ < 0.4 * this->maxHealth_)
-        {
+        if ((this->health_ < 0.4 * this->maxHealth_) && (this->healthMem_ == 60))
+        {
+            this->healthMem_ = 40;
             ChatManager::message("ShipPart " + this->getName() + " remaining health is 40%!");
             return;
         }
-        if (this->health_ < 0.6 * this->maxHealth_)
-        {
+        if ((this->health_ < 0.6 * this->maxHealth_) && (this->healthMem_ == 80))
+        {
+            this->healthMem_ = 60;
             ChatManager::message("ShipPart " + this->getName() + " remaining health is 60%!");
             return;
         }
-        if (this->health_ < 0.8 * this->maxHealth_)
-        {
+        if ((this->health_ < 0.8 * this->maxHealth_) && (this->healthMem_ == 100))
+        {
+            this->healthMem_ = 80;
             ChatManager::message("ShipPart " + this->getName() + " remaining health is 80%!");
             return;
Index: /code/branches/modularships/src/orxonox/items/ShipPart.h
===================================================================
--- /code/branches/modularships/src/orxonox/items/ShipPart.h	(revision 10070)
+++ /code/branches/modularships/src/orxonox/items/ShipPart.h	(revision 10071)
@@ -72,6 +72,5 @@
                 { return this->parent_; }
 
-            inline void setAlive(bool var)
-                { this->alive_ = var; }
+            void setAlive(bool var);
             inline bool isAlive()
                 { return this->alive_; }
@@ -125,4 +124,6 @@
             bool eventExecution_;
 
+            float healthMem_;
+
             Vector3 explosionPosition_;
 
Index: /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.cc
===================================================================
--- /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.cc	(revision 10070)
+++ /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.cc	(revision 10071)
@@ -50,5 +50,5 @@
 namespace orxonox
 {
-    SetConsoleCommand("ModularSpaceShip", "killshippart", &ModularSpaceShip::killShipPart);
+    SetConsoleCommand("ModularSpaceShip", "killshippart", &ModularSpaceShip::killShipPartStatic);
 
     RegisterClass(ModularSpaceShip);
@@ -174,4 +174,23 @@
     /**
     @brief
+        STATIC: Needed for consolecommand. Kills the ShipPart with the given name. Used from the console-command "ModularSpaceShip killshippart [string]".
+    @param name
+        The name of the part to be killed.
+    */
+    void ModularSpaceShip::killShipPartStatic(std::string name)
+    {
+        for (std::map<StaticEntity*, ShipPart*>::const_iterator it = ModularSpaceShip::partMap_s->begin(); it != ModularSpaceShip::partMap_s->end(); ++it)
+        {
+            if (it->second->getName() == name)
+            {
+                it->second->setAlive(false);
+                return;
+            }
+        }
+        orxout(internal_warning) << "Could not apply damage to ShipPart \"" << name << "\". Part not found." << endl;
+    }
+
+    /**
+    @brief
         Kills the ShipPart with the given name. Used from the console-command "ModularSpaceShip killshippart [string]".
     @param name
@@ -180,9 +199,9 @@
     void ModularSpaceShip::killShipPart(std::string name)
     {
-        for (std::map<StaticEntity*, ShipPart*>::const_iterator it = ModularSpaceShip::partMap_s->begin(); it != ModularSpaceShip::partMap_s->end(); ++it)
+        for (std::map<StaticEntity*, ShipPart*>::const_iterator it = ModularSpaceShip::partMap_.begin(); it != ModularSpaceShip::partMap_.end(); ++it)
         {
             if (it->second->getName() == name)
             {
-                it->second->death();
+                it->second->setAlive(false);
                 return;
             }
Index: /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.h
===================================================================
--- /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.h	(revision 10070)
+++ /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.h	(revision 10071)
@@ -113,5 +113,6 @@
             virtual void damage(float damage, float healthdamage = 0.0f, float shielddamage = 0.0f, Pawn* originator = NULL, const btCollisionShape* cs = NULL);
 
-            static void killShipPart(std::string name);
+            static void killShipPartStatic(std::string name);
+            void killShipPart(std::string name);
 
             void addShipPart(ShipPart* part);
